<template>
  <div class="component-container">
    <lenna-modal ref="lennaModal"></lenna-modal>
    <!-- <lenna-loading v-show="isLoading"></lenna-loading> -->
    <div>
      <h3 class="text-primary">Integrate with Whatsapp Messenger</h3>
      <hr>
      <form @submit.prevent="submitForm">
        <div class="form-group">
          <span class="text-muted">Select Whatsapp API Service you want to use.</span>
        </div>
        <div class="form-group row">
          <strong class="col-sm-12 col-form-label">API Service</strong>
          <div class="col-sm-10">
            <select name="api-service" id class="form-control" v-model="form.apiService">
              <option value="apiwha">APIWHA</option>
              <option value="infobip">Whatsapp Business INFOBIP</option>
            </select>
          </div>
        </div>
        <br>
        <div class="form-group">
          <span
            class="text-muted"
          >Fill in the required credentials below to connect with your Whatsapp Channel.</span>
        </div>

        <template v-if="selectedService == 'apiwha'">
          <div class="form-group row">
            <strong class="col-sm-12 col-form-label">Api Key</strong>
            <div class="col-sm-10">
              <textarea
                name="api key"
                v-validate="'required'"
                class="form-control"
                v-model="form.apiKey"
                placeholder="Api Key"
                rows="2"
                spellcheck="false"
              ></textarea>
              <span class="text-danger">{{ errors.first('api key') }}</span>
            </div>
          </div>
        </template>

        <template v-if="selectedService == 'infobip'">
          <div class="form-group row">
            <strong class="col-sm-12 col-form-label">Authorization Api Key</strong>
            <div class="col-sm-10">
              <textarea
                name="api key"
                v-validate="'required'"
                class="form-control"
                v-model="form.apiKey"
                placeholder="Api Key"
                rows="2"
                spellcheck="false"
              ></textarea>
              <span class="text-danger">{{ errors.first('api key') }}</span>
            </div>
          </div>
          <div class="form-group row">
            <strong class="col-sm-12 col-form-label">Scenario Key</strong>
            <div class="col-sm-10">
              <textarea
                name="scenario key"
                v-validate="'required'"
                class="form-control"
                v-model="form.scenarioKey"
                placeholder="Scenario Key"
                rows="2"
                spellcheck="false"
              ></textarea>
              <span class="text-danger">{{ errors.first('scenario key') }}</span>
            </div>
          </div>
          <div class="form-group row">
            <strong class="col-sm-12 col-form-label">Whatsapp Base Url</strong>
            <div class="col-sm-10">
              <input
                name="whatsapp base url"
                v-validate="'required'"
                class="form-control"
                v-model="form.whatsappBaseUrl"
                placeholder="https://{yourId}.api.infobip.com"
              >
              <span class="text-danger">{{ errors.first('whatsapp base url') }}</span>
            </div>
          </div>
        </template>
        <br>
        <div class="form-group">
          <span
            class="text-muted"
          >You can use this webhook URL to get the callback from Whatsapp api service</span>
        </div>
        <div class="form-group row">
          <strong class="col-sm-12 col-form-label">Webhook URL</strong>
          <div class="col-sm-10">
            <input
              type="text"
              class="form-control"
              id="webhook-url"
              v-model="this.webhookUrl"
              placeholder="Webhook URL"
              readonly
            >
          </div>
          <div class="col-sm-2">
            <button class="btn h-100 btn-rounded btn-primary w-75" @click.prevent="handleCopy">Copy</button>
          </div>
        </div>
        <br>
        <div class="form-group row">
          <input type="hidden" v-model="form.status">
          <div class="col-sm-6">
            <button
              type="button"
              class="btn btn-rounded btn-block"
              :class="(!form.status) ? 'btn-secondary': 'btn-danger'"
              :disabled="!form.status"
              @click="disconnectChannel"
            >Disconnect</button>
          </div>
          <div class="col-sm-6">
            <button
              type="submit"
              class="btn btn-rounded btn-block btn-primary"
            >{{(form.status) ? 'Update': 'Connect'}}</button>
          </div>
        </div>
      </form>
    </div>
  </div>
</template>
<script>
import EventBus from "@/EventBus.js";
export default {
  data() {
    return {
      form: {
        apiKey: "",
        scenarioKey: "",
        apiService: "infobip",
        status: false,
        channelName: "whatsapp",
        whatsappBaseUrl: ""
      },
      postfixWebhook: ""
    };
  },
  computed: {
    webhookUrl() {
      return (
        this.baseUrl +
        "/api/" +
        this.$store.getters.appId.hashed +
        "/webhook/whatsapp" +
        this.postfixWebhook
      );
    },
    selectedService() {
      return this.form.apiService;
    }
  },
  methods: {
    handleCopy() {
      let copyCode = document.querySelector("#webhook-url");
      copyCode.setAttribute("type", "text");
      copyCode.select();
      document.execCommand("copy");
    },
    async disconnectChannel() {
      try {
        let data = {
          channelName: this.form.channelName,
          status: false
        };
        let response = await this.$axios.put(
          `api/${this.$store.getters.appId.hashed}/integrate/update`,
          data
        );
        response = response.data;

        this.$refs.lennaModal.show("info", "Success", response.message);

        this.form.status = false;
        EventBus.$emit("toggleStatusMain", "facebook");
      } catch (error) {
        this.form.status = !this.form.status;
        this.$refs.lennaModal.show(
          "alert",
          "Sorry",
          error.response.data.message
        );
      }
    },
    async submitForm() {
      let validated = await this.$validator.validateAll();

      if (validated) {
        try {
          let formData = {
            ...this.form,
            status: true,
            webhookUrl: this.webhookUrl
          };
          let response = await this.$axios.post(
            `api/${this.$store.getters.appId.hashed}/integrate`,
            formData
          );
          this.form.status = true;

          this.$refs.lennaModal.show("info", "Success", response.data.message);

          EventBus.$emit("toggleStatusMain", "whatsapp");
        } catch (error) {
          this.$refs.lennaModal.show("alert", "Error", "Something wrong!");
        }
      } else {
        this.$refs.lennaModal.show(
          "alert",
          "Sorry",
          "You must correct your form first"
        );
      }
    },
    async fetchData() {
      let response = await this.$axios.get(
        `api/${this.$store.getters.appId.hashed}/integrate`
      );
      response = response.data;
      let channelData = response.data.find(function(item) {
        return item.name == "whatsapp";
      }).integration;

      if (channelData != null) {
        this.form.apiKey = channelData.integration_data.apiKey;
        this.form.apiService = channelData.integration_data.apiService;
        this.form.whatsappBaseUrl =
          channelData.integration_data.whatsappBaseUrl;
        this.form.scenarioKey = channelData.integration_data.scenarioKey;
        this.form.status = channelData.status;
      }
    }
  },
  mounted() {
    this.fetchData();

    EventBus.$on("toggleStatus", value => {
      this.fetchData();
    });
  },
  watch: {
    selectedService: function(val) {
      switch (val) {
        case "infobip":
          this.postfixWebhook = "";
          break;
        case "apiwha":
          this.postfixWebhook = "apiwha";
          break;
        default:
          this.postfixWebhook = "";

          break;
      }
      console.log(this.postfixWebhook);
    }
  }
};
</script>
<style lang="scss">
.component-container {
  position: relative;
}
</style>
